
/*
   Copyright 2001-2003 David Santinoli
   Released under the GPL. See file COPYING for details.
*/

import java.awt.*;
import java.util.StringTokenizer;
import java.net.URLDecoder;

public class deviceFrame extends Frame {

 private int cnt=0, special=0, currDev=0;
 private device devArray[];
 private Frame devFrame;

private class widgetSet {
 private Component wc;
 private Label l1;
 private Label l2;
 private Label ln;
 private Label lval;
 }

private class device {
 private String name;
 private char typ;
 private widgetSet widgetset;
 private boolean isSpecial=false;
 private int imin=0, imax=0;
 private String fmin="", fmax="";
 private float scale=0, offset=0;
 private int dir;
 private int lastval;
 private boolean isYBar=false;

/*
 public device(String n, String t, pclient cli) {
    name = new String(n);
    type=t.charAt(0);
*/
 }

 public void openDeviceFrame() {
    devFrame = new Frame("Device status");
    currDev=0;
    }

 public void setVisible(boolean a) {
    devFrame.setVisible(a);
    //System.out.println("Size "+devFrame.getSize(null));
    }

 public void initDevices(int d) {
    int i;
    cnt=d;
    devArray = new device[d];
    for(i=0;i<d;i++) {
       devArray[i]=new device();
       devArray[i].widgetset = new widgetSet();
       }

    devFrame.setLayout(new GridLayout(0,5,3,3));
    //devFrame.setVisible(true);
    //devFrame.setSize(500,300);
    currDev=0;
    special=0;
    //cli.xslider.setVisible(false);
    //cli.yslider.setVisible(false);
    //cli.zslider.setVisible(false);
    }

 public void flushDevices() {
    int i;
    for(i=0;i<cnt;i++) { /* XXX */
       if(!devArray[i].isSpecial) {
          devFrame.remove(devArray[i].widgetset.wc);
          devFrame.remove(devArray[i].widgetset.l1);
          devFrame.remove(devArray[i].widgetset.l2);
          devFrame.remove(devArray[i].widgetset.ln);
          devFrame.remove(devArray[i].widgetset.lval);
          devArray[i].widgetset.wc=null;
          devArray[i].widgetset.ln=null;
          }
       else devArray[i].widgetset.wc.setVisible(false);
       devArray[i].widgetset=null;
       devArray[i]=null;
       }
    if(cnt>0) devArray=null;
    cnt=0;
    }

 public void addDevice(String s, pclient cli) {
    String n = null, v = null, dName = null;
    char type='s';
    StringTokenizer nv, def = new StringTokenizer(s,"; ");

    //System.out.println("[Device definition] "+s);
    while(def.hasMoreTokens()) {
       nv = new StringTokenizer(def.nextToken(),"=");
       n = nv.nextToken();
       v = nv.nextToken();
       try {
       if("name".equals(n)) dName = URLDecoder.decode(v,"UTF-8");
       else if("imax".equals(n)) devArray[currDev].imax = Integer.parseInt(v);
       else if("imin".equals(n)) devArray[currDev].imin = Integer.parseInt(v);
       else if("fmax".equals(n)) devArray[currDev].fmax = v;
       else if("fmin".equals(n)) devArray[currDev].fmin = v;
       else if("dir".equals(n))  devArray[currDev].dir = Integer.parseInt(v);
       else if("type".equals(n)) devArray[currDev].typ = v.charAt(0);
          } catch (Exception e) {
             e.printStackTrace();
             }
       } // while

    devArray[currDev].name = dName;

    if(devArray[currDev].typ=='t') devArray[currDev].typ='s';

    if(devArray[currDev].typ=='x' || devArray[currDev].typ=='y' || devArray[currDev].typ=='z') {
       special++;
       devArray[currDev].isSpecial=true;
       }

    try {
       devArray[currDev].scale=
         (Float.parseFloat(devArray[currDev].fmax)-Float.parseFloat(devArray[currDev].fmin))
          /(devArray[currDev].imax-devArray[currDev].imin);
       devArray[currDev].offset=Float.parseFloat(devArray[currDev].fmin)
          -devArray[currDev].scale*devArray[currDev].imin;
       } catch (Exception e) {
          devArray[currDev].scale=0;
       }

    if(devArray[currDev].isSpecial) {
       if(devArray[currDev].typ=='x') {
          devArray[currDev].widgetset.wc = cli.xslider;
          }
       else if(devArray[currDev].typ=='y') {
          devArray[currDev].widgetset.wc = cli.yslider;
          devArray[currDev].isYBar = true;
          }
       else if(devArray[currDev].typ=='z') {
          devArray[currDev].widgetset.wc = cli.zslider;
          }
       devArray[currDev].widgetset.wc.setVisible(true);
       devArray[currDev].typ='s';
       }

    if(devArray[currDev].typ=='s' && !devArray[currDev].isSpecial) {
       devArray[currDev].widgetset.wc = new Scrollbar(
          Scrollbar.HORIZONTAL,127,40,0,2750);
       //devArray[currDev].widgetset.wc.setBounds(new Rectangle(20,200,0,0));
       devFrame.add(devArray[currDev].widgetset.wc);
       }

    else if(devArray[currDev].typ=='p') {
       //pbControl = new ProgressBar(100,20);
       // gauge required here!
       devArray[currDev].widgetset.wc = new Label();
       }

    if(!devArray[currDev].isSpecial) {
       devArray[currDev].widgetset.ln = new Label(dName);
       devArray[currDev].widgetset.l1 = new Label(devArray[currDev].fmin);
       devArray[currDev].widgetset.l1.setAlignment(Label.RIGHT);
       devArray[currDev].widgetset.l2 = new Label(devArray[currDev].fmax);
       devArray[currDev].widgetset.lval = new Label("");
       }

    if(devArray[currDev].typ=='s' || devArray[currDev].isSpecial) {
       int m=(devArray[currDev].imax-devArray[currDev].imin)/10;
       if(m==0) m=1;
       ((Scrollbar)devArray[currDev].widgetset.wc).setValues(
          (devArray[currDev].imax+devArray[currDev].imin)/2,
          m,
          devArray[currDev].imin,
          devArray[currDev].imax+m
          );
       }
    devArray[currDev].lastval=
       (devArray[currDev].imax+devArray[currDev].imin)/2;

    System.out.println("Added device "+dName);

    if(!devArray[currDev].isSpecial) {
       devFrame.add(devArray[currDev].widgetset.l1);
       devFrame.add(devArray[currDev].widgetset.wc);
       devFrame.add(devArray[currDev].widgetset.l2);
       devFrame.add(devArray[currDev].widgetset.ln);
       devFrame.add(devArray[currDev].widgetset.lval);
       }

    if(++currDev==cnt) devFrame.pack();
    }

 private void addParam(StringBuffer s, String par) {
    if(s.length()>0) s.append("; ");
    s.append(par);
    }

 public StringBuffer setParams(StringBuffer s) {
    //StringBuffer p = new StringBuffer();
    int i, v=0;

    for(i=0;i<cnt;i++) {
       if(devArray[i].dir==0) continue;
       if(devArray[i].typ=='s') {
          if(devArray[i].isYBar)
             v=devArray[i].imin+devArray[i].imax-((Scrollbar)(devArray[i].widgetset.wc)).getValue();
          else
             v=((Scrollbar)(devArray[i].widgetset.wc)).getValue();
          }

       if(devArray[i].lastval!=v) {
          devArray[i].lastval=v;
          addParam(s,new String("c"+i+"="+v));
          }
       }
    return s;
    }

 public void activateControls() {
    int i;
    for(i=0;i<cnt;i++)
       if(devArray[i].typ=='s') devArray[i].widgetset.wc.setEnabled(true);
    }

 public void deactivateControls() {
    int i;
    for(i=0;i<cnt;i++)
       if(devArray[i].typ=='s') devArray[i].widgetset.wc.setEnabled(false);
    }

 public boolean needDevBox() {
    return cnt != special;
    }

 public void setDevice(String s) {
    int pos,d,n;

    pos=s.indexOf('=');
    d=Integer.parseInt(s.substring(1,pos));
    n=Integer.parseInt(s.substring(pos+1));

    /* update label */
    if(!devArray[d].isSpecial) {
       devArray[d].widgetset.lval.setText( new String (String.valueOf(
          (devArray[d].scale*n + devArray[d].offset) ) )
          );
       }

    /* update control */
    if(devArray[d].typ=='s') {
       if(! ((Scrollbar)devArray[d].widgetset.wc).getValueIsAdjusting() ) {
          if(devArray[d].isYBar)
             n=devArray[d].imin+devArray[d].imax-n;
          ((Scrollbar)(devArray[d].widgetset.wc)).setValue(n);
          }
       }

    return;
    }
}
